diff -urN soojung-0.4.4/classes/Import.class.php soojung/classes/Import.class.php
--- soojung-0.4.4/classes/Import.class.php	2004-12-24 13:24:00.000000000 +0900
+++ soojung/classes/Import.class.php	2005-02-15 10:56:55.000000000 +0900
@@ -285,6 +285,66 @@
   }
 
   /**
+   * static method
+   */
+  function importZeroboard($dbServer, $dbUser, $dbPass, $dbName, $prefix, $encoding, $boardId) {
+    if (!$boardId)
+      die ("please specify the board id");
+
+    $link = mysql_connect($dbServer, $dbUser, $dbPass) or die("could not connect");
+    mysql_select_db($dbName) or die("could not select database");
+
+    // posts
+    $query = "select no, reg_date, category, use_html, name, subject, memo from " . $prefix . $boardId . " where depth = 0";
+    $result = mysql_query($query) or die("query failed");
+
+    while ($line = mysql_fetch_assoc($result)) {
+      $c_no = $line['category'];
+      $c_query = "select name from " . $prefix . "category_" . $boardId . " where no = " . $c_no;
+      $c_result = mysql_query($c_query);
+      $c_line = mysql_fetch_array($c_result);
+
+      $category = isset($c_line['name']) ? $c_line['name'] : "General";
+
+      if (strcasecmp($encoding, "UTF-8") == 0 || strcasecmp($encoding, "UTF8") == 0) {
+        $title = $line['subject'];
+        $body = stripslashes($line['memo']);
+      } else {
+        $title = iconv($encoding, "UTF-8", $line['subject']);
+        $body = iconv($encoding, "UTF-8", stripslashes($line['memo']));
+        $category = iconv($encoding, "UTF-8", $category);
+      }
+      $date = $line['reg_date'];
+      $options = array();
+      $format = "plain";
+      if ($line['use_html'])
+        $format = "html";
+
+      $id = Entry::createEntry($title, $body, $date, $category, $options, $format);
+
+      // comments
+      $comment_query = "select reg_date, name, memo from " . $prefix . "comment_" . $boardId . " where parent = " . $line['no'];
+      $comment_result = mysql_query($comment_query) or die("query failed");
+      while ($line = mysql_fetch_assoc($comment_result)) {
+        if (strcasecmp($encoding, "UTF-8") == 0 || strcasecmp($encoding, "UTF8") == 0) {
+          $name = $line['name'];
+          $body = $line['memo'];
+        } else {
+          $name = iconv($encoding, "UTF-8", $line['name']);
+          $body = iconv($encoding, "UTF-8", $line['memo']);
+        }
+        $date = $line['reg_date'];
+
+        Comment::writeComment($id, $name, $email, $homepage, $body, $date);
+      }
+      mysql_free_result($comment_result);
+    }
+
+    mysql_free_result($result);
+    mysql_close($link);
+  }
+
+  /**
    * private, static method
    */
   function createFile($xml) {
@@ -385,4 +445,5 @@
 
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/Soojung.class.php soojung/classes/Soojung.class.php
--- soojung-0.4.4/classes/Soojung.class.php	2005-02-05 00:21:17.000000000 +0900
+++ soojung/classes/Soojung.class.php	2005-02-20 11:13:25.000000000 +0900
@@ -64,6 +64,8 @@
       $i = strrpos($filename, "_") + 1;
       $j = strrpos($filename, ".");
       return substr($filename, $i, $j-$i);
+    } else if (strpos($filename, ".bookmark") != false) {
+      return basename($filename, ".bookmark");
     } else { //comment, trackback
       $dirs = explode("/", $filename);
       return $dirs[1];
@@ -129,8 +131,24 @@
   /**
    * static method
    */
+  function getFormatter($format) {
+    switch($format) {
+    case "plain":
+      return new PlainFormatter();
+    case "html":
+      return new HtmlFormatter();
+    case "bbcode":
+      return new BBcodeFormatter();
+    default:
+      return new Formatter();
+    }
+  }
+
+  /**
+   * static method
+   */
   function writeConfigFile($blogname, $blogdesc, $blogurl, $perpage, $blogfancyurl, $blognotify,
-			     $adminname, $adminemail, $adminpassword, $skin = "simple") {
+			     $adminname, $adminemail, $adminpassword, $skin = "simple", $license = "none") {
     $fd = fopen("config.php", "w");
     fwrite($fd, "<?php\n");
     fwrite($fd, '$blog_name="' . $blogname . "\";\n");
@@ -156,15 +174,31 @@
     } else {
       fwrite($fd, '$admin_password="' . $adminpassword . "\";\n");
     }
+    fwrite($fd, '$entries_license="' . $license . "\";\n");
     fwrite($fd, "?>");
     fclose($fd);
   }
 
+  function writeHtaccess($filename = ".htaccess") {
+    $f = fopen($filename, "w");
+    fwrite($f, "RewriteEngine On\n");
+    fwrite($f, "RewriteRule ^(.+)/([0-9]+)/([0-9]+)/([0-9]+)/([0-9]+)[.]html$ ");
+    fwrite($f, $_POST["url"] . "/entry.php?blogid=$5\n");
+    fwrite($f, "RewriteRule ^([0-9]+)/([0-9]+) ");
+    fwrite($f, $_POST["url"] . "/index.php?archive=$1$2\n");
+    fwrite($f, "RewriteRule ^([0-9]+)/([0-9]+)/([0-9]+) ");
+    fwrite($f, $_POST["url"] . "/index.php?archive=$1$2$3\n");
+    fwrite($f, "RewriteRule ^([^/.]+)$ ");
+    fwrite($f, $_POST["url"] . "/index.php?category=$1\n");
+    fwrite($f, "RewriteRule ^page/([0-9]+)$ ");
+    fwrite($f, $_POST["url"] . "/index.php?page=$1\n");
+    fclose($f);
+  }
 
   // referer spam check
   function isSpam($text) {
     $words = array("search", "blogspot", "naked", "nude", "boobs", "viagra",
-		   "poker", "password");
+		   "poker", "password", "sex", "porn", "hentai");
     foreach ($words as $word) {
       if (strpos($text, $word) !== FALSE) {
 	return true;
@@ -216,9 +250,15 @@
     if ($fd = @fopen("contents/.referer", "r")) {
       $data = @fread($fd, filesize("contents/.referer"));
       $array = split("\r\n", $data);
-      return array_slice($array, 0, $n);
+      $array = array_slice($array, 0, $n);
+
+      foreach($array as $key => $val) {
+	$array[$key] = htmlspecialchars($val);
+      }
+      return $array;
     }
   }
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/Template.class.php soojung/classes/Template.class.php
--- soojung-0.4.4/classes/Template.class.php	2005-01-05 22:29:14.000000000 +0900
+++ soojung/classes/Template.class.php	2005-02-12 22:53:01.000000000 +0900
@@ -19,4 +19,6 @@
     $this->assign('soojung_version', $soojung_version);
   }
 }
+
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/Trackback.class.php soojung/classes/Trackback.class.php
--- soojung-0.4.4/classes/Trackback.class.php	2004-11-19 22:58:30.000000000 +0900
+++ soojung/classes/Trackback.class.php	2005-02-19 13:13:04.000000000 +0900
@@ -119,10 +119,13 @@
       $tb_port = $tb_url['port'];
     else
       $tb_port = 80;
+    $tb_path = $tb_url['path'];
+    if($tb_path == '') $tb_path = '/';
+    if($tb_url['query']) $tb_path .= '?'.$tb_url['query'];
 
     //  $permlink = rawurlencode(get_entry_link($blogid, false));
     $entry = Entry::getEntry($entryId);
-    $permlink = $entry->getHref();
+    $permlink = rawurlencode($entry->getHref());
 
     if ($entry->title != null) {
       $tb_title = rawurlencode(iconv("UTF-8", $encoding, $entry->title));
@@ -145,12 +148,15 @@
 
     $query_string = "title=$tb_title&url=$permlink&excerpt=$tb_excerpt&blog_name=$tb_blogname";
     $query_string = iconv( "UTF-8", $encoding, $query_string);
-    echo "query_string : $query_string<br />"; //debug code?
 
-    $http_request  = 'POST '.$trackbackUrl." HTTP/1.0\r\n";
-    $http_request .= 'Content-Type: application/x-www-form-urlencoded'."\r\n";
-    $http_request .= 'Content-Length: '.strlen($query_string)."\r\n\r\n";
-    $http_request .= $query_string;
+    # only for debugging
+    #echo "query_string : $query_string<br />"; //debug code?
+
+    $http_request  = "POST ".$tb_path." HTTP/1.1\r\n";
+    $http_request .= "Host: ".$tb_url['host']."\r\n";
+    $http_request .= "Content-Type: application/x-www-form-urlencoded\r\n";
+    $http_request .= "Content-Length: ".strlen($query_string)."\r\n\r\n";
+    $http_request .= $query_string."\r\n\r\n";
 
     $response = array();
     if (!($fp = fsockopen($tb_url['host'], $tb_port))) {
@@ -182,4 +188,5 @@
 
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/classes/UserTemplate.class.php soojung/classes/UserTemplate.class.php
--- soojung-0.4.4/classes/UserTemplate.class.php	2005-01-22 19:43:49.000000000 +0900
+++ soojung/classes/UserTemplate.class.php	2005-02-19 18:02:46.000000000 +0900
@@ -6,6 +6,7 @@
   {
     global $blog_skin;
     global $today_count, $total_count;
+    global $entries_license;
 
     $this->Template();
     
@@ -43,6 +44,14 @@
       }
       $calendar = new Calendar($year, $month, $day);
       $this->assign('calendar', $calendar);
+
+      //license
+      if ($entries_license == "none") {
+	$license_link = "All rights reserved.";
+      } else {
+	$license_link = "This site is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/$entries_license/2.0/\">Creative Commons License</a>.";
+      }
+      $this->assign('license_link', $license_link);
     }
     $this->assign('today_count', $today_count);
     $this->assign('total_count', $total_count);
@@ -53,4 +62,6 @@
     $this->clear_all_cache();
   }
 }
-?>
\ No newline at end of file
+
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/entry.php soojung/entry.php
--- soojung-0.4.4/entry.php	2005-01-18 22:39:56.000000000 +0900
+++ soojung/entry.php	2005-02-12 22:52:45.000000000 +0900
@@ -56,4 +56,6 @@
 }
 
 $template->display('entry.tpl', $blogid);
+
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/index.php soojung/index.php
--- soojung-0.4.4/index.php	2005-01-14 22:38:44.000000000 +0900
+++ soojung/index.php	2005-02-12 22:52:45.000000000 +0900
@@ -53,4 +53,6 @@
   }
 }
 $template->display('index.tpl', $cache_id);
+
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/install.php soojung/install.php
--- soojung-0.4.4/install.php	2005-01-05 22:10:20.000000000 +0900
+++ soojung/install.php	2005-02-19 18:37:52.000000000 +0900
@@ -1,5 +1,6 @@
 <?php
-include_once("settings.php");
+include_once("classes/Soojung.class.php");
+include_once("libs/util.php");
 ?>
 
 <html>
@@ -47,18 +48,7 @@
     Soojung::writeConfigFile($_POST["name"], $_POST["desc"], $_POST["url"], $_POST["perpage"],
 			     $fb, $nb, $_POST["admin"], $_POST["email"],
 			     md5($_POST["password"]));
-
-    $f = fopen(".htaccess", "w");
-    fwrite($f, "RewriteEngine On\n");
-    fwrite($f, "RewriteRule ^(.+)/([0-9]+)/([0-9]+)/([0-9]+)/([0-9]+)[.]html$ ");
-    fwrite($f, $_POST["url"] . "/entry.php?blogid=$5\n");
-    fwrite($f, "RewriteRule ^([0-9]+)/([0-9]+) ");
-    fwrite($f, $_POST["url"] . "/index.php?archive=$1$2\n");
-    fwrite($f, "RewriteRule ^([^/.]+)$ ");
-    fwrite($f, $_POST["url"] . "/index.php?category=$1\n");
-    fwrite($f, "RewriteRule ^page/([0-9]+)$ ");
-    fwrite($f, $_POST["url"] . "/index.php?page=$1\n");
-    fclose($f);
+    Soojung::writeHtaccess();
 
     echo "install success. delete install.php file and change the soojung directory permission to 755<br />";
     echo "<a href=\"index.php\">home</a>";
@@ -123,3 +113,7 @@
 
 </body>
 </html>
+
+<?php
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/libs/smarty/plugins/shared.make_timestamp.php soojung/libs/smarty/plugins/shared.make_timestamp.php
--- soojung-0.4.4/libs/smarty/plugins/shared.make_timestamp.php	2004-08-30 21:22:54.000000000 +0900
+++ soojung/libs/smarty/plugins/shared.make_timestamp.php	2005-02-18 23:09:07.000000000 +0900
@@ -19,7 +19,7 @@
         $string = "now";
     }
     $time = strtotime($string);
-    if (is_numeric($time) && $time != -1)
+    if (is_numeric($time) && $time != -1 && $time <= 0x7FFFFFFF)
         return $time;
 
     // is mysql timestamp format of YYYYMMDDHHMMSS?
diff -urN soojung-0.4.4/libs/util.php soojung/libs/util.php
--- soojung-0.4.4/libs/util.php	2004-11-12 07:56:52.000000000 +0900
+++ soojung/libs/util.php	2005-02-19 05:43:23.000000000 +0900
@@ -64,108 +64,6 @@
   return rmdir($dirname);
 }
 
-/** Balances Tags of string using a modified stack.
- * @param text      Text to be balanced
- * @return          Returns balanced text
- * @notes           
- * import from Wordpress
- * add balance quot
- */
-function balanceTags($text, $is_comment = 0) {
-  /*	
-  if (get_settings('use_balanceTags') == 0) {
-    return $text;
-  }
-  */
-  $tagstack = array(); 
-  $stacksize = 0; 
-  $tagqueue = ''; 
-  $newtext = '';
-
-# WP bug fix for comments - in case you REALLY meant to type '< !--'
-  $text = str_replace('< !--', '<    !--', $text);
-# WP bug fix for LOVE <3 (and other situations with '<' before a number)
-  $text = preg_replace('#<([0-9]{1})#', '&lt;$1', $text);
-
-  // close &quot; which isn't closed in MARKUP
-  $text = ereg_replace("<([^=]*)=\"([^>\"]*)>", "<\\1=\"\\2\">", $text);
-  // match MARKUP tag, $regex[1] is tagname.
-
-  while (preg_match("/<(\/?\w*)\s*([^>]*)>/",$text,$regex)) {
-    $newtext = $newtext . $tagqueue;
-
-    $i = strpos($text,$regex[0]);
-    $l = strlen($tagqueue) + strlen($regex[0]);
-
-    // clear the shifter
-    $tagqueue = '';
-    // Pop or Push
-    if ($regex[1][0] == "/") { // End Tag
-      $tag = strtolower(substr($regex[1],1));
-      // if too many closing tags
-      if($stacksize <= 0) { 
-	$tag = '';
-	//or close to be safe $tag = '/' . $tag;
-      }
-      // if stacktop value = tag close value then pop
-      else if ($tagstack[$stacksize - 1] == $tag) { // found closing tag
-	$tag = '</' . $tag . '>'; // Close Tag
-	// Pop
-	array_pop ($tagstack);
-	$stacksize--;
-      } else { // closing tag not at top, search for it
-	for ($j=$stacksize-1;$j>=0;$j--) {
-	  if ($tagstack[$j] == $tag) {
-	    // add tag to tagqueue
-	    for ($k=$stacksize-1;$k>=$j;$k--){
-	      $tagqueue .= '</' . array_pop ($tagstack) . '>';
-	      $stacksize--;
-	    }
-	    break;
-	  }
-	}
-	$tag = '';
-      }
-    } else { // Begin Tag
-      $tag = strtolower($regex[1]);
-
-      // Tag Cleaning
-
-      // Push if not img or br or hr
-      if($tag != 'br' && $tag != 'img' && $tag != 'hr' ) {
-	$stacksize = array_push ($tagstack, $tag);
-      }
-
-      // Attributes
-      // $attributes = $regex[2];
-      $attributes = $regex[2];
-      if($attributes) {
-	$attributes = ' '.$attributes;
-      }
-      $tag = '<'.$tag.$attributes.'>';
-    }
-    $newtext .= substr($text,0,$i) . $tag;
-    $text = substr($text,$i+$l);
-  }  
-
-  // Clear Tag Queue
-  $newtext = $newtext . $tagqueue;
-
-  // Add Remaining text
-  $newtext .= $text;
-
-  // Empty Stack
-  while($x = array_pop($tagstack)) {
-    $newtext = $newtext . '</' . $x . '>'; // Add remaining tags to close      
-  }
-
-  // WP fix for the bug with HTML comments
-  $newtext = str_replace("< !--","<!--",$newtext);
-  $newtext = str_replace("<    !--","< !--",$newtext);
-
-  return $newtext;
-}
-
 function trim_slash($str) {
   return trim($str, "/");
 }
@@ -259,4 +157,4 @@
   return trim($array[0]);
 }
 
-?>
\ No newline at end of file
+?>
diff -urN soojung-0.4.4/post.php soojung/post.php
--- soojung-0.4.4/post.php	2005-01-14 21:18:13.000000000 +0900
+++ soojung/post.php	2005-02-19 05:37:25.000000000 +0900
@@ -14,7 +14,9 @@
   die();
 } else if ($_POST["mode"] == "Post") {
   $title =  $_POST["title"];
-  $body = balanceTags($_POST["body"]);
+  $format = $_POST["format"];
+  $formatter = Soojung::getFormatter($format);
+  $body = $formatter->onPost($_POST["body"]);
   $date = strtotime($_POST["date"]);
   if (empty($_POST["category_input"]) == false) {
     $category = trim($_POST["category_input"]);
@@ -37,7 +39,6 @@
   if (isset($_POST["NO_RSS"])) {
     $options[] = "NO_RSS";
   }
-  $format = $_POST["format"];
 
   if (empty($title) || empty($body) || empty($date) || empty($format) || empty($category) ) {
     echo "<font color=\"red\">WARNING: Input title, body, date, category, format</font>";
@@ -59,7 +60,7 @@
   $entry = Entry::getEntry($_GET["blogid"]);
   $mode = "edit";
   $title = $entry->title;
-  $body = $entry->getBody(false);
+  $body = $entry->getRawBody();
   $date = $entry->date;
   $category = $entry->category->name;
   $options = $entry->options;
@@ -67,8 +68,10 @@
   $id = $entry->entryId;
 } else if ($_POST["mode"] == "Preview") {
   $mode = "preview";
-  $title =  $_POST["title"];
-  $body = balanceTags($_POST["body"]);
+  $title = $_POST["title"];
+  $format = $_POST["format"];
+  $formatter = Soojung::getFormatter($format);
+  $body = $formatter->onPost($_POST["body"]);
   $date = strtotime($_POST["date"]);
   if (empty($_POST["category_input"]) == false) {
     $category = trim($_POST["category_input"]);
@@ -91,7 +94,6 @@
   if (isset($_POST["NO_RSS"])) {
     $options[] = "NO_RSS";
   }
-  $format =  $_POST["format"];
   if (isset($_POST["id"]))
     $id = $_POST["id"];
 }
@@ -123,4 +125,6 @@
   $template->assign("format", $format);
 }
 $template->display('post.tpl');
+
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/rss2.php soojung/rss2.php
--- soojung-0.4.4/rss2.php	2005-01-04 20:51:52.000000000 +0900
+++ soojung/rss2.php	2005-02-19 05:37:25.000000000 +0900
@@ -37,7 +37,9 @@
     continue;
   }
 
-  $post_text = $e->getBody();
+  $post_text = $e->getRawBody();
+  $formatter = Soojung::getFormatter($e->format);
+  $post_text = $formatter->toRSS($post_text);
 
   echo "<item>\n";
   echo "<title>" . convenc($e->title) . "</title>\n";
@@ -52,3 +54,6 @@
 </channel>
 </rss>
 
+<?php
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/secure.sh soojung/secure.sh
--- soojung-0.4.4/secure.sh	1970-01-01 09:00:00.000000000 +0900
+++ soojung/secure.sh	2005-02-20 11:00:56.000000000 +0900
@@ -0,0 +1,12 @@
+#!/bin/sh
+# $Id: secure.sh,v 1.1 2005/02/20 02:00:56 ddt Exp $
+
+chmod 701 .
+RETVAL=0
+rm -f install.php
+if [ ! $RETVAL -eq 0 ]; then
+	echo 'Deleting install.php: failed. Please fix this problem and re-execute.'
+	exit
+fi
+
+echo 'OK.'
diff -urN soojung-0.4.4/sendping.php soojung/sendping.php
--- soojung-0.4.4/sendping.php	2005-02-04 23:53:37.000000000 +0900
+++ soojung/sendping.php	2005-02-19 13:13:03.000000000 +0900
@@ -4,8 +4,12 @@
 
 if ($_POST["mode"] == "post") {
   $blogid = $_POST['blogid'];
-  $trackback_url = $_POST['trackback_url'];
-  $encoding = $_POST['encoding'];
+  $trackback_url = $_POST["trackback_url"];
+  if (empty($_POST['encoding_input']) == false) {
+    $encoding = trim($_POST["encoding_input"]);
+  } else {
+    $encoding = $_POST["encoding"];
+  }
   if (empty($blogid) || empty($trackback_url) ){
     echo "input body, trackback_url";
     exit;
@@ -16,7 +20,7 @@
 /* show result of trackback ping */
   if ($result['error'] == 0) {
     echo "<html><head>\n";
-    //echo "<meta http-equiv='refresh' content='3;URL=admin.php'>";
+    echo "<meta http-equiv='refresh' content='3;URL=admin.php'>";
     echo "</head><body>\n";
     echo "Trackback sended successfully<br />\n";
     echo "After 3sec, or click <a href='admin.php'>admin page</a> to return admin page <br />\n";
@@ -45,12 +49,9 @@
 
 
 <?php
-$smarty = new UserTemplate("sendping.tpl", $blogid);
+$template = new AdminTemplate;
 
-$smarty->assign('entry', $entry);
-$smarty->assign('trackbacks', $entry->getTrackbacks());
-$smarty->assign('comments', $entry->getComments());
-
-$smarty->display('sendping.tpl');
+$template->assign('entry', $entry);
+$template->display('sendping.tpl');
+# vim: ts=8 sw=2 sts=2 noet
 ?>
-
diff -urN soojung-0.4.4/settings.php soojung/settings.php
--- soojung-0.4.4/settings.php	2005-02-04 14:27:06.000000000 +0900
+++ soojung/settings.php	2005-02-19 01:52:00.000000000 +0900
@@ -1,12 +1,14 @@
 <?php
 
-$soojung_version = '0.4.4';
+$soojung_version = '0.4.5';
 setlocale(LC_TIME, "C");
 
-if (file_exists("config.php")) {
-  include_once("config.php");
+if (!file_exists("config.php")) {
+  echo "please execute install.php first.";
+  exit;
 }
 
+include_once("config.php");
 include_once("libs/util.php");
 
 include_once("classes/Formatter.class.php");
@@ -48,7 +50,7 @@
       }
     }
     $return = "";
-    $fp = popen("echo \"$str\" | /usr/local/bin/iconv -c -f $in -t $out","r");
+    $fp = popen("echo ".escapeshellarg($str)." | /usr/local/bin/iconv -c -f $in -t $out","r");
     while(!feof($fp)) {
       $return .= fgets($fp,1024);
     }
@@ -111,4 +113,6 @@
 
 get_count();
 Soojung::addReferer();
+
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/setup.sh soojung/setup.sh
--- soojung-0.4.4/setup.sh	1970-01-01 09:00:00.000000000 +0900
+++ soojung/setup.sh	2005-02-20 11:20:14.000000000 +0900
@@ -0,0 +1,36 @@
+#!/bin/sh
+# $Id: setup.sh,v 1.2 2005/02/20 02:20:14 mithrandir Exp $
+
+curdir=`pwd`
+
+# 수정 블로그의 루트 디렉토리에서 실행하고 있는지 간단히 체크
+if [ ! -f $curdir/setup.sh -o ! -f $curdir/index.php ] ; then
+	echo "Oops! Execute this at soojung blog's root directory please."
+	echo
+	echo "  (ex) cd ~/public_html/soojung ; ./$0"
+	exit
+fi
+
+# chmod go+w .
+RETVAL=0
+chmod go+w .
+RETVAL=$?
+if [ ! $RETVAL -eq 0 ]; then
+	echo "chmod go+w . : failed. Fix this problem manually and re-execute."
+	exit
+else
+	echo "chmod go+w . : success."
+fi
+
+# chmod go+w templates
+RETVAL=0
+chmod go+w templates/
+RETVAL=$?
+if [ ! $RETVAL -eq 0 ]; then
+	echo "chmod gw+w templates : failed. Fix this problem manually and re-execute."
+	exit
+else
+	echo "chmod go+w templates : success."
+fi
+
+echo 'All is OK.'
diff -urN soojung-0.4.4/trackback.php soojung/trackback.php
--- soojung-0.4.4/trackback.php	2005-01-14 21:18:13.000000000 +0900
+++ soojung/trackback.php	2005-02-12 22:52:45.000000000 +0900
@@ -29,15 +29,12 @@
   exit;
 }
 
-if (isset($_POST["url"]) || isset($_GET["blogid"])) {
-  $id = $_GET["blogid"];
-  if (!isset($id))
-    $id = $_POST["blogid"];
-
-  $url = $_POST["url"];
-  $title = $_POST["title"];
-  $excerpt = $_POST["excerpt"];
-  $name = $_POST["blog_name"];
+if (isset($_REQUEST["url"]) || isset($_REQUEST["blogid"])) {
+  $id = $_REQUEST["blogid"];
+  $url = $_REQUEST["url"];
+  $title = $_REQUEST["title"];
+  $excerpt = $_REQUEST["excerpt"];
+  $name = $_REQUEST["blog_name"];
 
 
 #  $encoding_title = detect_encoding ($title);
@@ -50,9 +47,9 @@
 #    $name = iconv($encoding, "UTF-8", $_POST["blog_name"]);
 #  }
 
-  $title = convert_to_utf8($_POST["title"]);
-  $excerpt = convert_to_utf8($_POST["excerpt"]);
-  $name = convert_to_utf8($_POST["blog_name"]);
+  $title = convert_to_utf8($title);
+  $excerpt = convert_to_utf8($excerpt);
+  $name = convert_to_utf8($name);
   
   if (empty($url)) {
     echo '<?xml version="1.0" encoding="iso-8859-1"?>' . "\n";
@@ -77,4 +74,5 @@
   echo "</response>\n";
 }
 
+# vim: ts=8 sw=2 sts=2 noet
 ?>
diff -urN soojung-0.4.4/uninstall.php soojung/uninstall.php
--- soojung-0.4.4/uninstall.php	2004-10-16 13:04:31.000000000 +0900
+++ soojung/uninstall.php	2005-02-12 22:52:45.000000000 +0900
@@ -17,4 +17,6 @@
 rmdirr("templates/.admin_cache");
 rmdirr("templates/.admin_configs");
 rmdirr("templates/.admin_compile");
-?>
\ No newline at end of file
+
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/upload.php soojung/upload.php
--- soojung-0.4.4/upload.php	2004-12-24 10:34:55.000000000 +0900
+++ soojung/upload.php	2005-02-19 00:24:21.000000000 +0900
@@ -27,10 +27,12 @@
     if ($file == "." || $file == "..") {
       continue;
     }
-    $list[] = "contents/upload/" . $file;
+    $list[] = array("path" => "contents/upload/" . $file, "name" => $file);
   }
 }
 $template->assign("files", $list);
 
 $template->display("upload.tpl");
-?>
\ No newline at end of file
+
+# vim: ts=8 sw=2 sts=2 noet
+?>
diff -urN soojung-0.4.4/xmlrpc.php soojung/xmlrpc.php
--- soojung-0.4.4/xmlrpc.php	2004-10-16 13:04:31.000000000 +0900
+++ soojung/xmlrpc.php	2005-02-19 11:08:17.000000000 +0900
@@ -343,7 +343,7 @@
 				       "description" => new xmlrpcval($content, "string")
 				       ), "struct");
 
-    $structarray[] = $entrystruct;
+    $structarray[] = $entrystruct; !d!,
   }
   return new xmlrpcresp(new xmlrpcval($structarray, "array"));
 
@@ -355,10 +355,13 @@
 			     "metaWeblog.newMediaObject" => array("function" => "metaWeblog_newMediaObject"),
 			     "metaWeblog.getCategories" => array("function" => "metaWeblog_getCategories"),
 			     "metaWeblog.getRecentPosts" => array("function" => "metaweblog_getRecentPosts"),
+			     "blogger.getPost" => array("function" => "blogger_getPost"),
 			     "blogger.newPost" => array("function" => "blogger_newPost"),
 			     "blogger.editPost" => array("function" => "blogger_editPost"),
 			     "blogger.deletePost" => array("function" => "blogger_deletePost"),
 			     "blogger.getRecentPosts" => array("function" => "blogger_getRecentPosts"),
 			     "blogger.getUsersBlogs" => array("function" => "blogger_getUsersBlogs"),
 			     "blogger.getUserInfo" => array("function" => "blogger_getUserInfo")));
-?>
\ No newline at end of file
+
+# vim: ts=8 sw=2 sts=2 noet
+?>
